;;APIHOOK.ASM (mathiisalive@yahoo.com)  on 16-Feb-2006
;;Converted from apihook.c (included in the bottom). 
;;
;;Here we Hook the MessageBoxA API. 
;;First find the start address of the MessageBoxA API in user32.dll
;;then just replace the first 6 bytes starting from that address with the code to jump to our function..(MyMessageBoxA)
;;in MyMessageBoxA function restore the 6 bytes using unhook function..
;;(do some changes to input params if wanted..) and call MessageBoxA (normal flow ).
;;In this pgm i have concatenated the string "(hooked by <your name> :)" )
;;Then replace the 6 bytes with jump code again so that the hook is still in place...
;;
;;This program works fine in win2k..

;;assemble with $> nasmw -fobj apihook.asm
;;link with 	$> alink -c -oPE -subsys gui apihook
;;
;; ***when assembling it gives two warnings..***

%include "nagoa+.inc"

API MessageBoxA,user32.dll
API ExitProcess,kernel32.dll
API ReadProcessMemory,kernel32.dll
API WriteProcessMemory,kernel32.dll
API GetProcAddress,kernel32.dll
API GetCurrentProcess,kernel32.dll
API GetModuleHandleA,kernel32.dll

segment .data USE32

segment .bss USE32
hook resb 6
newmessage resb 64
segment .code USE32 class=code

..start:
	call MessageBoxA,0, "HEY1","apihook", MB_OK  ;;normal execution..
	
	loccall HookFunction,"user32.dll", "MessageBoxA", MyMessageBoxA, hook  ;;hook the api
	
	call MessageBoxA,0, "HEY2","apihook", MB_OK  ;;MyMessageBoxA will be executed..
	call MessageBoxA,0, "HEY3","apihook", MB_OK  ;;MyMessageBoxA will be executed..
	
	loccall UnHookFunction,"user32.dll","MessageBoxA", hook ;;unhook
	
	call MessageBoxA,0,"HEY AGAIN","apihook",MB_OK ;;Normal execution.
	
	call ExitProcess,0 ;get out


proc MyMessageBoxA,hwnd,lptext,lpcaption,utype
	loccall UnHookFunction,"user32.dll","MessageBoxA", hook
	loccall m_strcpy,[@lptext],newmessage
	loccall m_strcat,newmessage,"(hooked by <your name> :) )"
	call MessageBoxA,[@hwnd],newmessage,[@lpcaption],[@utype]
	push eax
	
	loccall HookFunction,"user32.dll", "MessageBoxA", MyMessageBoxA, hook
	
	pop eax
endproc

proc HookFunction,lpModule,lpFuncName,lpFunction,lpBackup
	stack dwAddr,4,dwCalc,4
	call GetModuleHandleA,[@lpModule]
	call GetProcAddress,eax,[@lpFuncName]
	mov [@dwAddr],eax
	jmp afterjumpcode

	segment .data USE32
	jumpcode:	db 0xe9 ;;jmp
			db 0x00,0x00,0x00,0x00 ;;the address
			db 0xc3 ;;retn
	segment .code USE32
    afterjumpcode:
	call GetCurrentProcess
	push eax 		;;save eax.
	call ReadProcessMemory,eax,[@dwAddr],[@lpBackup],6,0  ;;take backup of first 6 bytes.
	mov eax,[@lpFunction]
	sub eax,[@dwAddr]
	sub eax,5
	mov edi,jumpcode+1 	;;calculate jump address = MyMessageBox - MsgBoxAddress - 5
				;;(can anyone explain me why this 5)
	stosd			;; store jump address (now jump code is ready).
	pop eax 		;;eax = getcurrentprocess (remember?? we pushed sometime back)
	call WriteProcessMemory,eax,[@dwAddr],jumpcode,6,0  ;; copy the jump code to start address of messagebox fn...(hooked!!!)
	mov eax,[@dwAddr]
endproc

proc UnHookFunction,lpModule,lpFuncName,lpBackup
	stack dwAddr,4
	call GetModuleHandleA,[@lpModule]
	call GetProcAddress,eax,[@lpFuncName]
	mov [@dwAddr],eax
	call GetCurrentProcess
	call WriteProcessMemory,eax,[@dwAddr],[@lpBackup],6,0 ;; restore the 6 bytes from backup (unhooked!)
	if eax,ne,0
		return TRUE
	else
		return FALSE
	endif
endproc

;;Normal string concatenation
proc m_strcat,first_string,second_string
	pusha
	mov edi,[@first_string]
	mov al,0
	mov ecx,-1
	repne scasb
	dec edi
	mov esi,[@second_string]
	mov al,1
	while al,ne,0
		lodsb
		stosb
	wend
	popa
endproc
;;Normal string copy
proc m_strcpy,src_string,dest_string
	pusha
	
	mov esi,[@src_string]
	mov edi,[@dest_string]
	mov al,1
	while al,ne,0
		lodsb
		stosb
	wend
	
	popa
endproc

%if 0 ;;multiline nasm comment. :)

/*
	API HOOKING Technique

	Hooking api is one of many ways we can control the way windows & 3rd party
	software behaves under certain circumstances. This technique shown here
	is a global api hook for the current process address space.

	It works by putting together a buffer with machine code instructions that
	cause a jump to a place in memory when executed. So when we hook the 
	specific api, we place this code inside of the exported function causing
	an unconditional jump when the export is called.

	Thanks,

	.::ANUBIS::.

*/
#include <windows.h>
#include <stdio.h>

DWORD HookFunction(LPCSTR lpModule, LPCSTR lpFuncName, LPVOID lpFunction, unsigned char *lpBackup);
BOOL UnHookFunction(LPCSTR lpModule, LPCSTR lpFuncName, unsigned char *lpBackup);
int MyMessageBoxA(HWND hWnd, LPCSTR lpText, LPCSTR lpCaption, UINT uType);

BYTE hook[6];


void WinMainCRTStartup()
{

	HookFunction("user32.dll", "MessageBoxA", MyMessageBoxA, hook);

	MessageBox(0, "HEY", "", MB_OK);

}

int MyMessageBoxA(HWND hWnd, LPCSTR lpText, LPCSTR lpCaption, UINT uType)
{
	UnHookFunction("user32.dll", "MessageBoxA", hook);

	char msg[strlen(lpText)];
	sprintf(msg, "HOOKED!!\n\n%s", lpText);

	int x = MessageBox(hWnd, msg, lpCaption, uType);

	HookFunction("user32.dll", "MessageBoxA", MyMessageBoxA, hook);
	return x;
}



DWORD HookFunction(LPCSTR lpModule, LPCSTR lpFuncName, LPVOID lpFunction, unsigned char *lpBackup)
{
	DWORD dwAddr = (DWORD)GetProcAddress(GetModuleHandle(lpModule), lpFuncName);
	BYTE jmp[6] = { 0xe9,	//jmp
		0x00, 0x00, 0x00, 0x00,	//address
		0xc3
	};	//retn

	ReadProcessMemory(GetCurrentProcess(), (LPVOID)dwAddr, lpBackup, 6, 0);

	DWORD dwCalc = ((DWORD)lpFunction - dwAddr - 5);	//((to)-(from)-5)

	memcpy(&jmp[1], &dwCalc, 4);	//build the jmp

	WriteProcessMemory(GetCurrentProcess(), (LPVOID)dwAddr, jmp, 6, 0);

	return dwAddr;
}

BOOL UnHookFunction(LPCSTR lpModule, LPCSTR lpFuncName, unsigned char *lpBackup)
{
	DWORD dwAddr = (DWORD)GetProcAddress(GetModuleHandle(lpModule), lpFuncName);

	if (WriteProcessMemory(GetCurrentProcess(), (LPVOID)dwAddr, lpBackup, 6, 0))
		return TRUE;

	return FALSE;
}

%endif ;;end multicomment .:)